
var startY,                                                  // 触摸点的坐标
    clientY,                                                 // 触摸点的坐标
    content = document.body,                                 // body元素
    imag = document.getElementById('imgBanner'),         // 要放大的图片dom
    header = document.getElementById('banner1'),   // 图片所在的区域
    imgWidth = imag.width,                                   // 图片元素宽
    imgHeight = imag.height;          // 图片元素高

// 监听body touch事件开始
content.addEventListener('touchstart', function(event) {

    var touch = event.touches[0];
    startY = touch.pageY;
    clientY = touch.clientY;
    console.log(startY,clientY);
}, {
    'passive': false
});

// 监听header touch事件开始
header.addEventListener('touchstart', function(event) {
    var touch = event.touches[0];
    startY = touch.pageY;
    clientY = touch.clientY;
    // 防止header触摸和body滚动条冲突
    stop(event);
}, {
    'passive': false
});

// 监听body 触摸移动时事件
content.addEventListener('touchmove', function(event) {
    imgTouchmove(event);
}, false);

// 监听header 触摸移动时事件
header.addEventListener('touchmove', function(event) {
    imgTouchmove(event);
}, false);

// touchmove事件执行的方法
function imgTouchmove(event) {


    var touchs = event.touches[0];
    var scrollT = document.body.scrollTop || document.documentElement.scrollTop;
    //向上滚动,直接返回
    if(touchs.clientY - startY <= 0) {
        return false;
    }
    //不相等说明屏幕已经向上翻动,image不需要放大效果
    if(startY != clientY) {
        return false;
    }
    $('#banner1').show();
    $('#banner').hide();
    //图片底部的容器高度+拖动的高度
    header.style.height = imgHeight + (touchs.pageY - startY) / 6 + 'px';
    //图片放大比例
    var scale = ((touchs.clientY - startY) / imgHeight) / 10;
    //图片放大
    imag.style.transform = "scale(" + scale + "," + scale + ")";
    // 防止header变化中和body滑动冲突
    bodyScroll(event);
};

// 触摸结束事件
content.addEventListener('touchend', function(event) {

    // 计算图片放大后的大小和原大小的差  使用计时器平滑还原
    var diff = imag.getBoundingClientRect().height - imgHeight;
    var restore;
    if(diff > 0) {
        restore = setInterval(function(){
            diff = diff - 5;

            if(diff > 0){
                console.log(diff)
                header.style.height = imgHeight + diff + 'px';
            } else {
                header.style.height = imgHeight + 'px';
                clearInterval(restore);
            }
        }, 1);
    };

    imag.style.transform = "none";
    $('#banner').show();
    $('#banner1').hide();

    // 滑动完成还原事件
    start();
});

// 禁用body事件
function stop(event) {
    content.removeEventListener('touchmove', bodyScroll, false);
    content.style.position = 'fixed';
    content.style.overflow = 'hidden';
};

// 还原事件
function start() {
    content.removeEventListener('touchmove', bodyScroll, false);
    header.removeEventListener('touchmove', bodyScroll, false);
    content.style.overflow = '';
    content.style.position = 'relative';
};

//防止事件冲突
function bodyScroll(event) {
    event.preventDefault();
};
